<?php

namespace App\Models;

use Encore\Admin\Traits\AdminBuilder;
use Encore\Admin\Traits\ModelTree;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class Category extends Model
{

    use AdminBuilder, ModelTree;

    public const TYPE_SHOW    = 'show';
    public const TYPE_ARTICLE = 'article';
    public const TYPE_ADVERT  = 'advert';
    public const TYPE_PERSON  = 'person';
    public const TYPES        = [
        self::TYPE_ARTICLE => '文章列表',
        self::TYPE_SHOW    => '文章详情',
        self::TYPE_ADVERT  => '图片',
        self::TYPE_PERSON  => '简历',
    ];

    public function getLinkAttribute()
    {
        return route('category.show', $this);
    }

    /**
     * 关联的数据
     *
     * @return [type] [description]
     */
    public function relations()
    {
        switch ($this->type) {
            case self::TYPE_SHOW:
                return $this->belongsTo(Article::class);
                break;
            case self::TYPE_ARTICLE:
                return $this->belongsToMany(Article::class);
                break;
            case self::TYPE_ADVERT:
                return $this->hasMany(Advert::class);
                break;
            case self::TYPE_PERSON:
                return $this->hasMany(Resume::class);
                break;
            default:
                return null;
        }
    }

    public function childrens()
    {
        return $this->hasMany(self::class, 'parent_id');
    }

    public function parent()
    {
        return $this->hasOne(self::class, 'id', 'parent_id');
    }

    public function articles(): BelongsToMany
    {
        return $this->belongsToMany(Article::class);
    }

    /**
     * Notes: 获取当前分类及子分类ID
     *
     * @Author: <C.Jason>
     * @Date  : 2020/4/6 3:12 下午
     * @return array
     */
    public function getAllChildrenId()
    {
        $ids = array_keys($this->buildSelectOptions([], $this->id));
        array_unshift($ids, $this->id);

        return $ids;
    }

    public function getTop()
    {
        $parent = $this;

        while ($parent->parent_id) {
            $parent->parent;
        }

        return $parent;
    }

    /**
     * Notes: 获取下级分类数量
     *
     * @Author: 玄尘
     * @Date: 2021/12/10 15:27
     * @return int
     */
    public function getChildrenCount(): int
    {
        return $this->childrens()->where('status', 1)->count();
    }

}
